/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 * 
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TASK_TIME_H_
#define _TASK_TIME_H_

#include <time.h>

class TaskTime
{
public:
    TaskTime();
    TaskTime(const char *);
    TaskTime(int year, int month, int day);
    virtual ~TaskTime();
    char *TimeText();
    void TimeFromString(const char *str);
    void TimeFromStringNoCheck(const char *str);
    int GetYear();
    int GetMonth();
    int GetDay();
    int GetWeekDay();

    TaskTime AddTime(const TaskTime &t);
    TaskTime SubTime(const TaskTime &t);
    TaskTime AddDay(int days);
    char *DateText();
    long Minutes();
    bool operator<(const TaskTime &other) const;
protected:

private:
    struct tm timeInfo;
};

#endif // _TASK_TIME_H_
